﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices; // DllImport

namespace ForkEach {
    class Program {

        static void Main(string[] args){
            // string extStr = "Test"; 
            string [] col = {"0","1","2","3","4","5","6","7","8","9"};
            ForkEach<string>.IN(col,delegate(string item){
                Console.Out.WriteLine(item); // see the output order
            });
            Console.Out.WriteLine();

            int[] arr = {0,1,2};
            try{
                ForkEach<int>.IN(arr,delegate(int itm){
                    if(itm>0){
                        throw new Exception("Test Exception"); 
                    }
                });
            } catch (Exception ex){
                Console.Out.WriteLine(ex.Message);
                if(null != ex.InnerException){
                    Console.Out.WriteLine(ex.InnerException.Message);
                }
            }
            Console.Out.WriteLine();

            example(100,10);
            example(100,100);
            example(500,10);
            example(500,100);
            example(1000,10);
            example(1000,100);
            example(5000,10);
            example(5000,1000);
            example(50000,10);
            System.Console.Out.WriteLine("Press enter to exit");
            System.Console.In.ReadLine();
        }


        [DllImport("kernel32.dll")]
        private static extern uint GetTickCount();

        public static void dowork(int item){
            for (int i = 0; i < item; i++) {
                for (int j = 0; j < (item - i); j++) {
                    int temp = i * j;
                }
            }
        }

        public static void example(int bias, int colSize) {
            System.Console.Out.WriteLine("Computing with complexity = "+bias+" Collection size = "+colSize);

            int[] arrInt = new int[colSize];
            for(int i = 0; i < colSize; ++i){
                arrInt[i]=bias;
            }


            uint start = GetTickCount();
            ForkEach<int>.IN(arrInt, true, delegate(int item) { // anonymous method
                for (int i = 0; i < item; i++) {
                    for (int j = 0; j < (item - i); j++) {
                        int temp = i * j;
                    }
                }
            });
            uint end = GetTickCount();
            System.Console.Out.WriteLine("ForkEach time in tics: " + (end - start));

            start = GetTickCount();
            ForkEach<int>.IN(arrInt, new ForkEach<int>.GenDelegate(dowork));
            end = GetTickCount();
            System.Console.Out.WriteLine("Non-locking ForkEach time in tics: " + (end - start));

            start = GetTickCount();
            foreach (int item in arrInt) {
                for (int i = 0; i < item; i++) {
                    for (int j = 0; j < (item - i); j++) {
                        int temp = i * j;
                    }
                }
            }
            end = GetTickCount();
            System.Console.Out.WriteLine("foreach time in tics: " + (end - start));
            System.Console.Out.WriteLine("");
        }


    } // class
} //namespace
